#ifndef LPROG_H
#define LPROG_H
				    

struct Loadable_Program 
{
  unsigned int    imageSize;  /* total size of the image, including text and data */
  unsigned long   entryPoint; /* initial program counter; execution starts here    */ 
  unsigned char * image;      /* pointer to the whole image */
};

/* Read_Elf_Executable will create, fill in and return a 
 * struct Loadable_Program   
 */
struct Loadable_Program * Read_Elf_Executable(char *programName);

/* Spawner is a a thread that accomodates the program to be loaded & executed
 * it is started from main.c
 */

void                      Spawner(unsigned long arg);

/* 
 * Spawn_Program() sets up the memory space and kickstarts the program
 */

int Spawn_Program( struct Loadable_Program * lp );

#endif // LPROG_H
